package com.maroontress.gcovparser;

import java.util.ArrayDeque;
import java.util.ArrayList;
import java.util.Collection;
import java.util.TreeMap;

/**
   ؿդΥΡɤȤʤܥ֥åݥ饹Ǥ

   @param <T> ֥åζݥ饹
   @param <U> ζݥ饹
*/
public abstract class AbstractBlock<T extends AbstractBlock<T, U>,
				    U extends AbstractArc<T, U>> {

    /** ֥åμ̻ҤǤ */
    private int id;

    /** ֥åΥե饰Ǥ */
    private int flags;

    /** 륢פΥꥹȤǤ */
    private ArrayList<U> inArcs;

    /** ¹ԲȽ륢פνǤ */
    private ArrayDeque<U> solvedInArcs;

    /** ¹Բʡ륢פνǤ */
    private ArrayDeque<U> unsolvedInArcs;

    /** ֽФ륢פΥꥹȤǤ */
    private ArrayList<U> outArcs;

    /** ¹ԲȽֽФ륢פΥꥹȤǤ */
    private ArrayDeque<U> solvedOutArcs;

    /** ¹ԲʡֽФ륢פΥꥹȤǤ */
    private ArrayDeque<U> unsolvedOutArcs;

    /** ֥åμ¹ԲǤ */
    private long count;

    /**
       Block is a call instrumenting site; does the call: ؿƤӽФ
       ¬֥åʥˤǤ뤳Ȥ򼨤ޤ
    */
    private boolean callSite;

    /**
       Block is a call instrumenting site; is the return: ؿƤӽФ
       ¬֥åʥ꥿ˤɤޤ
    */
    private boolean callReturn;

    /**
       Block is a landing pad for longjmp or throw: longjmp()ޤ
       throwǤsetjmp()ޤcatchǤˤȤ򼨤ޤ
    */
    private boolean nonLocalReturn;

    /** ֥åб륽ɤιԥȥǤ */
    private LineEntry[] lines;

    /**
       ֥åޤ

       @param id ֥åμ̻
       @param flags ֥åΥե饰
    */
    protected AbstractBlock(final int id, final int flags) {
	this.id = id;
	this.flags = flags;
	this.count = -1;
	inArcs = new ArrayList<U>();
	solvedInArcs = new ArrayDeque<U>();
	unsolvedInArcs = new ArrayDeque<U>();
	outArcs = new ArrayList<U>();
	solvedOutArcs = new ArrayDeque<U>();
	unsolvedOutArcs = new ArrayDeque<U>();
    }

    /**
       ȤޤȤͭǤʤȤ0֤ޤ

       @return 
    */
    public final long getCount() {
	return (count < 0) ? 0 : count;
    }

    /**
       Ȥͭޤ

       @return ȤͭʤtrueǤʤfalse
    */
    public final boolean getCountValid() {
	return (count >= 0);
    }

    /**
       ؿƤӽФ¬֥åʥˤɤꤷޤ

       @param b ؿƤӽФ¬֥åʥˤξtrue
       ʤfalse
    */
    public final void setCallSite(final boolean b) {
	callSite = b;
    }

    /**
       catchޤsetjmp()ޤ֥åɤꤷޤ

       @param b catchޤsetjmp()ޤ֥åξtrue
       ʤfalse
    */
    public final void setNonLocalReturn(final boolean b) {
	nonLocalReturn = b;
    }

    /**
       ԥȥޤ

       @return ԥȥ
    */
    public final LineEntry[] getLines() {
	return lines;
    }

    /**
       Υ֥å˥ɲäޤ

       @param arcs Υꥹ
       @param unsolvedArcs ¹Բʥν
       @param solvedArcs ¹ԲȽ륢ν
       @param arc 
    */
    private void addArc(final ArrayList<U> arcs,
			final ArrayDeque<U> unsolvedArcs,
			final ArrayDeque<U> solvedArcs,
			final U arc) {
	arcs.add(arc);
	if (arc.isOnTree()) {
	    unsolvedArcs.add(arc);
	} else {
	    solvedArcs.add(arc);
	}
    }

    /**
       Υ֥å륢ɲäޤ

       @param arc 
    */
    public final void addInArc(final U arc) {
	addArc(inArcs, unsolvedInArcs, solvedInArcs, arc);
    }

    /**
       Υ֥åФ륢ɲäޤ

       @param arc 
    */
    public final void addOutArc(final U arc) {
	addArc(outArcs, unsolvedOutArcs, solvedOutArcs, arc);
    }

    /**
       Υ֥åιԥȥꤷޤ

       @param lines ԥȥ
    */
    public final void setLines(final LineEntry[] lines) {
	this.lines = lines;
    }

    /**
       ̻Ҥޤ

       @return ̻
    */
    public final int getId() {
	return id;
    }

    /**
       륢פΥꥹȤޤ

       @return 륢פΥꥹ
    */
    public final ArrayList<U> getInArcs() {
	return inArcs;
    }

    /**
       ֽФ륢פΥꥹȤޤ

       @return ֽФ륢פΥꥹ
    */
    public final ArrayList<U> getOutArcs() {
	return outArcs;
    }

    /**
       ե饰ޤ

       @return ե饰
    */
    public final int getFlags() {
	return flags;
    }

    /**
       ؿƤӽФ¬֥åʥˤɤޤ

       @return ؿƤӽФ¬֥åʥˤξtrue
       ʤfalse
    */
    public final boolean isCallSite() {
	return callSite;
    }

    /**
       ؿƤӽФ¬֥åʥ꥿ˤɤޤ

       @return ؿƤӽФ¬֥åʥ꥿ˤξtrue
       Ǥʤfalse
    */
    public final boolean isCallReturn() {
	return callReturn;
    }

    /**
       Υ֥ålongjmp()ޤthrowǤsetjmp()ޤ
       catchǤˤɤޤ

       @return Υ֥ålongjmp()ޤthrowǤ
       trueǤʤfalse
    */
    public final boolean isNonLocalReturn() {
	return nonLocalReturn;
    }

    /**
       եդ򤯤ν򤷤ޤ

       ֥åФ뵶Ǥʤ1Ĥʤ硢Υ̵
       ʬꤷޤˡΥ֥åָƤ
       ФפǤ뤫ɤꤷޤ
    */
    public final void presolve() {
	int nonFakeArcs = 0;
	U lastNonFakeArc = null;

	for (U a : outArcs) {
	    if (!a.isFake()) {
		lastNonFakeArc = a;
		++nonFakeArcs;
	    }
	}
	if (nonFakeArcs != 1) {
	    return;
	}
	U arc = lastNonFakeArc;
	AbstractBlock destBlock = arc.getEnd();
	/*
	  If there is only one non-fake exit, it is an unconditional
	  branch.
	*/
	arc.setUnconditional(true);
	/*
	  If this block is instrumenting a call, it might be an
	  artificial block. It is not artificial if it has a
	  non-fallthrough exit, or the destination of this arc has
	  more than one entry.  Mark the destination block as a return
	  site, if none of those conditions hold.
	*/
	if (callSite
	    && arc.isFallThrough()
	    && destBlock.inArcs.get(0) == arc
	    && destBlock.inArcs.size() == 1) {
	    destBlock.callReturn = true;
	}
    }

    /**
       ֽФ륢פΥꥹȤ򤽤νλ֥åμ̻ҽ˥Ȥ
       
    */
    public final void sortOutArcs() {
	TreeMap<Integer, U> map = new TreeMap<Integer, U>();
	for (U a : outArcs) {
	    map.put(a.getEnd().getId(), a);
	}
	outArcs.clear();
	outArcs.addAll(map.values());
    }

    /**
       ν礫¹Բޤ

       @param arcs ν
       @return ¹Բ
    */
    private long sumCount(final Collection<U> arcs) {
	long total = 0;
	for (U a : arcs) {
	    total += a.getCount();
	}
	return total;
    }

    /**
       ¹Բޤ

       @param arcs Υꥹ
       @param unsolvedArcs ¹ԲʥΥꥹ
       @return ¹ԲޤätrueǤʤfalse
    */
    private boolean validateCount(final ArrayList<U> arcs,
				  final ArrayDeque<U> unsolvedArcs) {
	if (arcs.size() > 0 && unsolvedArcs.size() == 0) {
	    count = sumCount(arcs);
	    return true;
	}
	return false;
    }

    /**
       ¹Բޤ

       륢פμ¹Բ٤ƵޤäƤ뤫ֽФ륢
       μ¹Բ٤ƵޤäƤ硢¤֥åμ
       ԲȤƷ׻֥å򥽥Фɲäޤ

       륢פȡֽФ륢פΤɤ¹ԲޤäƤ
       ϲ⤷ޤ

       @param s եե
    */
    public final void validate(final Solver s) {
	if (validateCount(inArcs, unsolvedInArcs)
	    || validateCount(outArcs, unsolvedOutArcs)) {
	    s.addValid(this);
	}
    }

    /**
       ֽФ륢פμ¹ԲȽȤ˸ƤӽФޤ

       ֥åμ¹ԲȽƤϡ֥åֽФ
       פΤ¹ԲȽƤʤμ¹Բǽ
       ʤޤ

       ֥åμ¹Բʾϡ֥åμ¹Բǽʤ
       ޤη̤ȶ˥Ф˥֥åɲäޤ

       @param s եե
       @param arc ¹ԲȽ
    */
    private void validateInSideBlock(final Solver s, final U arc) {
	unsolvedOutArcs.remove(arc);
	solvedOutArcs.add(arc);
	if (inArcs.size() > 0 && unsolvedInArcs.size() == 0) {
	    /* ˼¹ԲȽƤ */
	    if (unsolvedOutArcs.size() == 1) {
		validateOutSide(s);
	    }
	} else {
	    /* ޤ¹Բ */
	    s.add(this, validateCount(outArcs, unsolvedOutArcs));
	}
    }

    /**
       ¹Բʡ륢פ1ĤǤꡢĥ֥åμ
       ԲȽȤ˸ƤӽФ졢٤ƤΡ륢פμ¹
       Ƚޤ

       ¹ԲȽγϥ֥åˤĤơƵŪ˼¹Բ
       ޤ

       @param s եե
    */
    private void validateInSide(final Solver s) {
	U arc = unsolvedInArcs.remove();
	arc.setCount(count - sumCount(solvedInArcs));
	solvedInArcs.add(arc);
	/* arcФ֥åˤĤƤν */
	arc.getStart().validateInSideBlock(s, arc);
    }

    /**
       륢פμ¹ԲȽȤ˸ƤӽФޤ

       ֥åμ¹ԲȽƤϡ֥åˡ륢
       פΤ¹ԲȽƤʤμ¹Բǽʤ
       ޤ

       ֥åμ¹Բʾϡ֥åμ¹Բǽʤ
       ޤη̤ȶ˥Ф˥֥åɲäޤ

       @param s եե
       @param arc ¹ԲȽ
    */
    private void validateOutSideBlock(final Solver s, final U arc) {
	unsolvedInArcs.remove(arc);
	solvedInArcs.add(arc);
	if (outArcs.size() > 0 && unsolvedOutArcs.size() == 0) {
	    /* ˼¹ԲȽƤ */
	    if (unsolvedInArcs.size() == 1) {
		validateInSide(s);
	    }
	} else {
	    /* ޤ¹Բ */
	    s.add(this, validateCount(inArcs, unsolvedInArcs));
	}
    }

    /**
       ¹ԲʡֽФ륢פ1ĤǤꡢĥ֥åμ
       ԲȽȤ˸ƤӽФ졢٤ƤΡֽФ륢פμ¹
       Ƚޤ

       ¹ԲȽνλ֥åˤĤơƵŪ˼¹Բ
       ޤ

       @param s եե
    */
    private void validateOutSide(final Solver s) {
	U arc = unsolvedOutArcs.remove();
	arc.setCount(count - sumCount(solvedOutArcs));
	solvedOutArcs.add(arc);
	/* arc֥åˤĤƤν */
	arc.getEnd().validateOutSideBlock(s, arc);
    }

    /**
       ֥å륢Ф륢줾ˤĤơ¹Բ
       ʤΤ1Ĥʤ顢μ¹Բޤ

       ֥åϴ˼¹ԲȽƤɬפޤ

       @param s եե
    */
    public final void validateSides(final Solver s) {
	if (unsolvedInArcs.size() == 1) {
	    validateInSide(s);
	}
	if (unsolvedOutArcs.size() == 1) {
	    validateOutSide(s);
	}
    }
}
